package prompt.roles.data;

import java.io.Serializable;

/**
 * 
 * @author Andrea Burattin
 * @param <S>
 * @param <F>
 */
public class SerializablePair<S extends Serializable, F extends Serializable> implements Serializable {

	private static final long serialVersionUID = -8349499208764045247L;
	protected S second;
	protected F first;

	/**
	 * 
	 * @param first
	 * @param second
	 */
	public SerializablePair(F first, S second) {
		this.first = first;
		this.second = second;
	}

	/**
	 * 
	 * @return
	 */
	public F getFirst() {
		return first;
	}

	/**
	 * 
	 * @return
	 */
	public S getSecond() {
		return second;
	}

	/**
	 * 
	 * @param x
	 * @param y
	 * @return
	 */
	private static boolean equals(Object x, Object y) {
		return ((x == null) && (y == null)) || ((x != null) && x.equals(y));
	}

	@SuppressWarnings("unchecked")
	@Override
	public boolean equals(Object other) {
		return (other instanceof SerializablePair) &&
				equals(first, ((SerializablePair<F, S>) other).getFirst()) &&
				equals(second, ((SerializablePair<F, S>) other).getSecond());
	}

	@Override
	public int hashCode() {
		if (first == null) {
			return second == null ? 0 : second.hashCode() + 1;
		} else {
			return second == null ? first.hashCode() + 2 : first.hashCode() * 17 + second.hashCode();
		}
	}

	@Override
	public String toString() {
		return "(" + first + "," + second + ")";
	}

}
