package prompt.roles.utils;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.extension.std.XOrganizationalExtension;
import org.deckfour.xes.model.XAttributable;
import org.deckfour.xes.model.XEvent;

/**
 * This class contains some utility methods to manage logs.
 * 
 * @author Andrea Burattin
 */
public class XLogHelper {

	/**
	 * This method returns the value of the attribute <tt>concept:name</tt> for
	 * the given attributable element
	 * 
	 * @param element the element to analyze
	 * @return the value of the <tt>concept:name</tt> attribute
	 */
	public static String getName(XAttributable element) {
		return XConceptExtension.instance().extractName(element);
	}

	/**
	 * This method returns the value of the attribute <tt>org:resource</tt> for
	 * the given attributable element
	 * 
	 * @param element the element to analyze
	 * @return the value of the <tt>org:resource</tt> attribute
	 */
	public static String getResource(XEvent element) {
		return XOrganizationalExtension.instance().extractResource(element);
	}
}
